/*-
 * %%----------------------------------------------------------------------------------------------
 * Solidify Framework - Solidify Frontend - extra-button-toolbar.model.ts
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2023 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

import {ElementRef} from "@angular/core";
import {Navigate} from "@ngxs/router-plugin";
import {ButtonColorEnum} from "../../enums/button-color.enum";
import {ButtonThemeEnum} from "../../enums/button-theme.enum";
import {DataTestPartialEnum} from "../../enums/partial/data-test-partial.enum";
import {IconNamePartialEnum} from "../../enums/partial/icon-name-partial.enum";
import {ExtendEnum} from "../../types/extend-enum.type";
import {BaseResource} from "../dto/base-resource.model";
import {ObservableOrPromiseOrValue} from "../observables/observable-or-promise-or-value.model";

export interface ExtraButtonToolbar<TResourceModel extends BaseResource> {
  color: ButtonColorEnum;
  class?: string | undefined;
  icon: ExtendEnum<IconNamePartialEnum>;
  typeButton?: ButtonThemeEnum;
  labelToTranslate: (current?: TResourceModel | undefined) => ObservableOrPromiseOrValue<string>;
  tooltipToTranslate?: string | undefined;
  navigate?: Navigate;
  callback?: (current?: TResourceModel | undefined, buttonElementRef?: ElementRef | undefined, checked?: boolean) => void;
  order?: number;
  dataTest?: ExtendEnum<DataTestPartialEnum>;
  displayCondition?: (current?: TResourceModel | undefined) => ObservableOrPromiseOrValue<boolean>;
  disableCondition?: (current?: TResourceModel | undefined) => ObservableOrPromiseOrValue<boolean>;
  isToggleButton?: boolean;
  isToggleChecked?: boolean;
}
