/*-
 * %%----------------------------------------------------------------------------------------------
 * Solidify Framework - Solidify Frontend - mock-translate.service.ts
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2023 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

import {
  EventEmitter,
  Injectable,
} from "@angular/core";
import {
  Observable,
  of,
  Subject,
} from "rxjs";
import {AbstractBaseService} from "../../services/abstract-base.service";

@Injectable()
export class MockTranslateService extends AbstractBaseService {

  private _translation: Subject<any> = new Subject();
  private _translationObs: Observable<any> = this._translation.asObservable();

  onLangChange: EventEmitter<any> = new EventEmitter();
  onTranslationChange: EventEmitter<any> = new EventEmitter();
  onDefaultLangChange: EventEmitter<any> = new EventEmitter();

  constructor() {
    super();
  }

  get(labels: string[]): Observable<string[]> {
    return of(labels);
  }

  getTranslation(labels: string[]): Observable<any> {
    setTimeout(() => this._translation.next(""), 10);
    return this._translationObs;
  }

  instant(labels: string | string[]): string | string[] {
    return labels;
  }

}
